#include "Cell.h"
#include <iostream>

using namespace std;

Cell::Cell(int x, int y) : m_x(x), m_y(y)
{

}

Cell::~Cell()
{
  // Nothing to destroy.
}

void Cell::add_neighb(Cell *n1)
{
  // Testing if n1 is already a known neighbour:
  for(int i = 0 ; i < m_nb_neighb ; i++)
    if(m_neighb[i] == n1)
      return;

  // If not:

  m_nb_neighb++;

  // We create a new array of neighbours with the previous cells...
  Cell **new_neighb = new Cell*[m_nb_neighb];
  for(int i = 0 ; i < m_nb_neighb - 1 ; i++)
    new_neighb[i] = m_neighb[i];
  // ... and the new one
  new_neighb[m_nb_neighb - 1] = n1;

  // (note: an array of pointers is a double pointer: **)

  // The old array of pointers is deleted (but not the cells)
  delete[] m_neighb;

  // The new one is considered as attribute of this class
  m_neighb = new_neighb;

  // The new neighbour has to know its own new neighbour: this
  n1->add_neighb(this);
}

void Cell::add_neighb(Cell *n1, Cell *n2)
{
  add_neighb(n1);
  add_neighb(n2);
}

void Cell::add_neighb(Cell *n1, Cell *n2, Cell *n3)
{
  add_neighb(n1);
  add_neighb(n2);
  add_neighb(n3);
}

ostream& operator<<(ostream& stream, const Cell& c)
{
  // Writing in the stream:
  stream << "(" << c.m_x << "," << c.m_y << ")";
  return stream;
}

istream& operator>>(istream& stream, Cell& c)
{
  char dump;
  stream >> dump >> c.m_x >> dump >> c.m_y >> dump;
  return stream; 
}