#ifndef __MAZE_H__
#define __MAZE_H__

#include <fstream>
#include "Cell.h"

struct Maze
{
  // A Maze is a graph structure: so it can be
  // defined only thanks to two pointers:
  Cell *c0, *cf;
  // All the cells can be reached from one of these.
};

void serialize_maze_graph(Cell *c, std::ofstream *f);
void serialize_maze(const Maze& maze, const std::string& file_name);
Maze deserialize_maze(const std::string& file_name);

Maze create_4x4_maze();
Maze create_8x8_maze();

#endif