#include "maze_examples.h"

Maze create_4x4_maze()
{
  Cell* a[4][4];
  for(int i = 0 ; i < 4 ; i++)
    for(int j = 0 ; j < 4 ; j++)
      a[i][j] = new Cell(i, j);

  a[0][1]->add_neighb(a[0][2], a[0][0]);
  a[1][0]->add_neighb(a[0][0], a[1][1]);
  a[1][2]->add_neighb(a[1][1], a[2][2]);
  a[2][1]->add_neighb(a[1][1], a[2][0]);
  a[3][0]->add_neighb(a[3][1], a[2][0]);
  a[3][2]->add_neighb(a[3][3], a[3][1]);
  a[2][3]->add_neighb(a[1][3], a[3][3]);
  a[0][3]->add_neighb(a[1][3]);

  Maze m;
  m.c0 = a[0][2]; m.cf = a[0][3];
  return m;
}

Maze create_8x8_maze()
{
  Cell* a[8][8];
  
  for(int i = 0 ; i < 8 ; i++)
    for(int j = 0 ; j < 8 ; j++)
      a[i][j] = new Cell(i, j);

  a[1][0]->add_neighb(a[0][0], a[2][0]);
  a[2][1]->add_neighb(a[2][0], a[1][1]);
  a[0][1]->add_neighb(a[0][2], a[1][1]);
  a[0][3]->add_neighb(a[0][2], a[0][4]);
  a[0][5]->add_neighb(a[0][4], a[1][5]);
  a[1][6]->add_neighb(a[1][5], a[1][7], a[0][6]);
  a[0][7]->add_neighb(a[0][6]);
  a[2][5]->add_neighb(a[1][5], a[2][6]);
  a[2][7]->add_neighb(a[2][6], a[3][7]);
  a[3][6]->add_neighb(a[3][5], a[4][6], a[3][7]);
  a[4][7]->add_neighb(a[5][7], a[4][6]);
  a[6][7]->add_neighb(a[6][6]);
  a[5][6]->add_neighb(a[5][7], a[5][5], a[6][6]);
  a[4][5]->add_neighb(a[5][5], a[4][4]);
  a[3][4]->add_neighb(a[4][4], a[2][4]);
  a[1][4]->add_neighb(a[2][4], a[1][3]);
  a[1][2]->add_neighb(a[1][3], a[2][2]);
  a[3][2]->add_neighb(a[2][2], a[3][1], a[4][2]);
  a[4][3]->add_neighb(a[4][2], a[5][3]);
  a[5][4]->add_neighb(a[5][3]);
  a[6][3]->add_neighb(a[6][4], a[6][2], a[5][3]);
  a[5][2]->add_neighb(a[5][3], a[5][1]);
  a[5][0]->add_neighb(a[5][1]);
  a[4][1]->add_neighb(a[4][0], a[3][1]);
  a[3][0]->add_neighb(a[4][0]);
  a[1][4]->add_neighb(a[2][4], a[1][3]);
  a[1][2]->add_neighb(a[1][3], a[2][2]);
  a[3][2]->add_neighb(a[2][2], a[3][1]);
  a[7][6]->add_neighb(a[7][7], a[7][5]);
  a[7][4]->add_neighb(a[7][5], a[7][3]);
  a[7][2]->add_neighb(a[7][3], a[7][1]);
  a[7][0]->add_neighb(a[7][1], a[6][0]);
  a[6][1]->add_neighb(a[6][0], a[6][2]);
  a[6][3]->add_neighb(a[6][2], a[6][4]);
  a[6][5]->add_neighb(a[6][3]);
  a[2][3]->add_neighb(a[3][3], a[1][3]);

  Maze m;
  m.c0 = a[0][0]; m.cf = a[7][7];
  return m;
}